package com.zase.nosql.pojo.utils;

import java.lang.reflect.Method;
import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBAttribute;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBAutoGeneratedKey;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBHashKey;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBIgnore;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBRangeKey;
import com.amazonaws.services.dynamodbv2.datamodeling.DynamoDBTable;



/**
 * Convenience method to get methods of a classs. 
 * Use Memoization so we improve the performance of this.
 * @author mramos
 *
 */
public class DynamoDBReflectionUtils {
	
	
	 public static Collection<Method> getRelevantGetters(Class<?> clazz) {
		List<Method> relevantGetters = new LinkedList<Method>();
        for ( Method m : clazz.getMethods() ) {
            if ( isRelevantAttributeGetter(m) ) {
                relevantGetters.add(m);
            }
        }
        return relevantGetters;
	  }
	 
	 
    private static boolean isRelevantAttributeGetter(Method m) {
        return (m.getName().startsWith("get") || m.getName().startsWith("is"))
	                && m.getParameterTypes().length == 0
	                && m.getDeclaringClass().getAnnotation(DynamoDBTable.class) != null
	                && m.isAnnotationPresent(DynamoDBAttribute.class)
	                && !m.isAnnotationPresent(DynamoDBIgnore.class)
	                && !m.isAnnotationPresent(DynamoDBAutoGeneratedKey.class)
	                && !m.isAnnotationPresent(DynamoDBHashKey.class)
	                && !m.isAnnotationPresent(DynamoDBRangeKey.class);
	                
    }
}
